package cokr.xit.fims.cmmn.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.fims.cmmn.CrdnPayerAddrHstry;
import cokr.xit.fims.cmmn.CrdnPayerHstryQuery;
import cokr.xit.fims.cmmn.dao.CrdnPayerAddrHstryMapper;
import cokr.xit.foundation.component.AbstractBean;
import cokr.xit.foundation.data.DataObject;

/**단속 납부자 이력 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-16	leebj 최초 작성
 * 2024-11-05   JoJH 단속 납부자 주소 이력 테이블 변경으로 인한 수정
 * ================================
 * </pre>
 */
@Component("crdnPayerAddrHstryBean")
public class CrdnPayerAddrHstryBean extends AbstractBean {
	/** 단속 납부자 이력 정보 DAO */
	@Resource(name = "crdnPayerAddrHstryMapper")
	private CrdnPayerAddrHstryMapper crdnPayerAddrHstryMapper;

	/**지정한 조건에 따라 단속 납부자 이력 목록을 조회하여 반환한다.
	 * @param req 단속 납부자 이력 조회 조건
	 * @return 단속 납부자 이력 목록
	 */
	public List<DataObject> getCrdnPayerHstryList(CrdnPayerHstryQuery req) {
		return crdnPayerAddrHstryMapper.selectCrdnPayerHstryList(req);
	}

	/**지정한 조건에 따라 단속 납부자 이력 객체들을 반환한다.
	 * @param req 단속 납부자 이력 조회 조건
	 * @return 단속 납부자 이력 객체 목록
	 */
	public List<DataObject> getCrdnPayerHstrys(CrdnPayerHstryQuery req) {
		return crdnPayerAddrHstryMapper.selectCrdnPayerHstrys(req);
	}

    /**단속 납부자 주소 이력 정보를 등록한다.
     * @param crdnPayerAddrHstry 단속 납부자 주소 이력
     * @return 저장 여부
     * <ul><li>저장됐으면 true</li>
     *     <li>그렇지 않으면 false</li>
     * </ul>
     */
    public boolean create(CrdnPayerAddrHstry crdnPayerAddrHstry) {
        return crdnPayerAddrHstryMapper.insertCrdnPayerAddrHstry(crdnPayerAddrHstry) == 1;
    }

    public int createCrdnPayerAddrHstry(CrdnPayerAddrHstry crdnPayerAddrHstry) {
        return crdnPayerAddrHstryMapper.insertCrdnPayerAddrHstry(crdnPayerAddrHstry);
    }

    /**단속 대장의 납부자 주소 정보를 수정한다.
     * @param crdnPayerAddrHstry 단속 납부자 주소 이력
     * @return 저장 여부
     * <ul><li>저장됐으면 true</li>
     *     <li>그렇지 않으면 false</li>
     * </ul>
     */
    public int updateCrdnPayerAddr(CrdnPayerAddrHstry crdnPayerAddrHstry) {
        return crdnPayerAddrHstryMapper.updateCrdnPayerAddr(crdnPayerAddrHstry);
    }

	/**단속 납부자 주소 이력 정보를 등록하고, 단속 대장의 납부자 정보를 수정한다.
	 * @param crdnPayerHstry 단속 납부자 이력
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
    public boolean createHstryUpdateCrdnPayerAddr(CrdnPayerAddrHstry crdnPayerAddrHstry) {
        // 단속 납부자 주소 이력(TB_CRDN_PAYER_ADDR_HSTRY) 대장을 등록한다.
        int rtnNocs = crdnPayerAddrHstryMapper.insertCrdnPayerAddrHstry(crdnPayerAddrHstry);
        if (rtnNocs != 1)
            throw new RuntimeException("납부자주소 이력 대장 등록 중 오류가 발생하였습니다.");        // 예외를 발생시켜서 DB Rollback

        // 단속 대장(TB_CRDN)을 수정한다.
        rtnNocs = updateCrdnPayerAddr(crdnPayerAddrHstry);
        if (rtnNocs != 1)
            throw new RuntimeException("단속 대장에 납부자, 주소 정보 수정 중 오류가 발생하였습니다.");  // 예외를 발생시켜서 DB Rollback

        return true;
    }
}